﻿Imports System.IO
Imports System.Drawing
Imports System.Text.RegularExpressions
Imports System.Web.UI.DataVisualization.Charting

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        Dim x() As String = New String() {"Mango", "Apple", "Orange", "Banana"}
        Dim y() As Integer = New Integer() {200, 112, 55, 96}
        Chart1.Series(0).Points.DataBindXY(x, y)
        Chart1.Series(0).ChartType = SeriesChartType.Pie
        Chart1.ChartAreas("ChartArea1").Area3DStyle.Enable3D = True
        Chart1.Legends(0).Enabled = True
    End Sub
    Protected Sub btnExportExcel_Click(sender As Object, e As EventArgs)
        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=ChartExport.xls")
        Response.ContentType = "application/vnd.ms-excel"
        Response.Charset = ""
        Dim sw As New StringWriter()
        Dim hw As New HtmlTextWriter(sw)
        Chart1.RenderControl(hw)
        Dim src As String = Regex.Match(sw.ToString(), "<img.+?src=[""'](.+?)[""'].+?>", RegexOptions.IgnoreCase).Groups(1).Value
        Dim table As String = "<table><tr><td><img src='{0}' /></td></tr></table>"
        table = String.Format(table, Request.Url.GetLeftPart(UriPartial.Authority) + src)
        Response.Write(table)
        Response.Flush()
        Response.End()
    End Sub

End Class
